# struct Symbol

- Symbol
- Value
- Object

##
Overview

A symbol is a constant that is identified by a name without you having to give it a numeric value.

    :hello
    :welcome
    :"123"
    :"symbol with spaces"

Internally a symbol is represented as an `Int32`, so it's very efficient.

You can't dynamically create symbols. When you compile your program, each symbol gets assigned a unique number.

##
Included Modules

- Comparable(Symbol)

##
Defined in:

##
Class Method Summary

- .needs_quotes?(string) : Bool

  Determines if a string needs to be quoted to be used for a symbol.

##
Instance Method Summary

- #!=(other : Symbol) : Bool

  Returns `true` if `self` is not equal to other.

- #<=>(other : Symbol)

  Compares symbol with other based on `String#<=>` method.

- #==(other : Symbol) : Bool

  Returns `true` if `self` is equal to other.

- #==(other : JSON::PullParser::Kind)

  DEPRECATED JSON::PullParser#kind now is an enum, please use that instead of symbols

- #clone
- #hash(hasher)

  See `Object#hash(hasher)`

- #inspect(io : IO) : Nil

  Returns the symbol literal representation as a string.

- #to_i : Int32

  Returns a unique number for this symbol.

- #to_json(json : JSON::Builder)
- #to_json_object_key
- #to_s(io : IO) : Nil

  Appends the symbol's name to the passed `IO`.

- #to_s : String

  Returns the symbol's name as a String.

- #to_yaml(yaml : YAML::Nodes::Builder)

### Instance methods inherited from module `Comparable(Symbol)`

<(other : T) <, <=(other : T) <=, <=>(other : T) <=>, ==(other : T) ==, >(other : T) >, >=(other : T) >=, clamp(min, max)
clamp(range : Range) clamp

### Instance methods inherited from struct `Value`

==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, __crystal_pseudo_! : Bool __crystal_pseudo_!, __crystal_pseudo_as(type : Class) __crystal_pseudo_as, __crystal_pseudo_as?(type : Class) __crystal_pseudo_as?, __crystal_pseudo_is_a?(type : Class) : Bool __crystal_pseudo_is_a?, __crystal_pseudo_nil? : Bool __crystal_pseudo_nil?, __crystal_pseudo_responds_to?(name : Symbol) : Bool __crystal_pseudo_responds_to?, class class, dup dup, hash(hasher)
hash hash, inspect : String
inspect(io : IO) : Nil inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Class Method Detail

def self.needs_quotes?(string) : Bool #

Determines if a string needs to be quoted to be used for a symbol.

    Symbol.needs_quotes? "string"      # => false
    Symbol.needs_quotes? "long string" # => true

##
Instance Method Detail

def !=(other : Symbol) : Bool #

Returns `true` if `self` is not equal to other.

def <=>(other : Symbol) #

Compares symbol with other based on `String#<=>` method. Returns `-1`, `0` or `1` depending on whether symbol is less than, equal to, or greater than other.

See `String#<=>` for more information.

def ==(other : Symbol) : Bool #

Returns `true` if `self` is equal to other.

def ==(other : JSON::PullParser::Kind) #

DEPRECATED JSON::PullParser#kind now is an enum, please use that instead of symbols

def clone #
def hash(hasher) #

See `Object#hash(hasher)`

def inspect(io : IO) : Nil #

Returns the symbol literal representation as a string.

    :crystal.inspect # => ":crystal"

def to_i : Int32 #

Returns a unique number for this symbol.

def to_json(json : JSON::Builder) #
def to_json_object_key #
def to_s(io : IO) : Nil #

Appends the symbol's name to the passed `IO`.

    :crystal.to_s # => "crystal"

def to_s : String #

Returns the symbol's name as a String.

    :foo.to_s           # => "foo"
    :"hello world".to_s # => "hello world"

def to_yaml(yaml : YAML::Nodes::Builder) #